package me.unurled.raxen.manager.server;

import java.util.HashMap;
import java.util.Map;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.clientbuild.Builds;
import me.unurled.raxen.components.clientbuild.PlayerList;
import org.bukkit.Location;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;

public class BuildManager {

    private Raxen raxen;

    private HashMap<Builds, PlayerList> builds;


    public BuildManager(Raxen raxen) {
        this.raxen = raxen;
        this.builds = new HashMap<>();
    }

    public HashMap<Builds, PlayerList> getBuilds() {
        return builds;
    }

    public void addBuild(Builds build, PlayerList pl) {
        builds.put(build, pl);
    }

    public void removeBuild(Builds build) {
        builds.remove(build);
    }

    public Builds getBuildByOwner(String owner) {
        for (Map.Entry<Builds, PlayerList> entry : builds.entrySet()) {
            if (entry.getKey().getOwner().toString().equals(owner)) {
                return entry.getKey();
            }
        }
        return null;
    }

    public HashMap<Builds, PlayerList> getBuildsByOwner(String owner) {
        HashMap<Builds, PlayerList> buildss = new HashMap<>();
        for (Map.Entry<Builds, PlayerList> build : builds.entrySet()) {
            if (build.getKey().getOwner().toString().equals(owner)) {
                buildss.put(build.getKey(), build.getValue());
            }
        }
        return buildss;
    }

    public Builds getBuildsByLocation(Location loc) {
        for (Map.Entry<Builds, PlayerList> build : builds.entrySet()) {
            for (Block b : build.getKey().getBlocks()) {
                Location bl = b.getLocation();
                if (bl.getWorld() == loc.getWorld() && bl.getBlockX() == loc.getBlockX()
                    && bl.getBlockY() == loc.getBlockY() && bl.getBlockZ() == loc.getBlockZ()) {
                    return build.getKey();
                }
            }
        }
        return null;
    }

    public boolean isABuild(Location loc) {
        for (Map.Entry<Builds, PlayerList> build : builds.entrySet()) {
            for (Block b : build.getKey().getBlocks()) {
                Location bl = b.getLocation();
                if (bl.getWorld() == loc.getWorld() && bl.getBlockX() == loc.getBlockX()
                    && bl.getBlockY() == loc.getBlockY() && bl.getBlockZ() == loc.getBlockZ()) {
                    return true;
                }
            }
        }
        return false;
    }

    public boolean isInPlayerList(Builds build, Player player) {
        if (!builds.containsKey(build)) {
            return false;
        }
        return builds.get(build).getPlayers().contains(player);
    }
}
