package me.unurled.raxen.manager.server;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import lombok.Getter;
import me.unurled.raxen.Raxen;
import me.unurled.raxen.components.glyph.Glyph;
import me.unurled.raxen.components.glyph.GlyphBuilder;
import me.unurled.raxen.config.GlyphConfig;

public class GlyphManager {

    private Raxen main;

    @Getter
    private HashMap<Character, Glyph> glyphs;
    private GlyphConfig glyphConfig;
    private Map<File, Map<String, GlyphBuilder>> map;

    public GlyphManager(Raxen main) {
        this.main = main;
        glyphs = new HashMap<>();
        registerGlyphs();
    }

    void registerGlyphs() {
        // TODO: register all glyphs
        glyphConfig = new GlyphConfig(main);
        map = glyphConfig.parseGlyphConfigs();
        final List<String> glyphList = new ArrayList<>();
        for (final Map<String, GlyphBuilder> subMap : map.values()) {
            glyphList.addAll(subMap.keySet());
        }
        for (String glyph : glyphList) {
//            registerGlyph(glyph);
        }
    }
}
