package me.unurled.raxen.manager.server;

import com.sk89q.worldedit.EditSession;
import com.sk89q.worldedit.WorldEdit;
import com.sk89q.worldedit.bukkit.BukkitAdapter;
import com.sk89q.worldedit.extent.clipboard.Clipboard;
import com.sk89q.worldedit.extent.clipboard.io.ClipboardFormat;
import com.sk89q.worldedit.extent.clipboard.io.ClipboardFormats;
import com.sk89q.worldedit.extent.clipboard.io.ClipboardReader;
import com.sk89q.worldedit.function.operation.Operation;
import com.sk89q.worldedit.math.BlockVector3;
import com.sk89q.worldedit.session.ClipboardHolder;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import lombok.Getter;
import me.unurled.raxen.components.tutorial.Tutorial;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.entity.Player;

public class TutorialManager {
    
    Map<UUID, Tutorial> tutorials = new HashMap<>();

    @Getter
    Map<UUID, Location> locations = new HashMap<>();

    double x = 0;
    double y = 0;
    double z = 0;

    static final double STEP = 150;

    public void addTutorial(Player player, Tutorial tutorial) {
        tutorials.put(player.getUniqueId(), tutorial);
        locations.put(player.getUniqueId(), player.getLocation());
    }

    public Tutorial getTutorial(UUID uuid) {
        return tutorials.get(uuid);
    }

    public void removeTutorial(UUID uuid) {
        tutorials.remove(uuid);
    }

    public Map<UUID, Tutorial> getTutorials() {
        return tutorials;
    }

    public void startTutorial(Player player) {
        if (tutorials.containsKey(player.getUniqueId())) {
            Tutorial tutorial = tutorials.get(player.getUniqueId());
            Location loc = generateTutorial(player);
            tutorial.startTutorial(player, loc);
        }
    }

    public Location generateTutorial(Player player) {
        double eX, eY, eZ;
        if (x == 0 && y == 0 && z == 0) {
            eX = 0;
            eY = 0;
            eZ = 0;
        } else {
            eX = x + STEP;
            eY = y;
            eZ = z;
        }
        World world = Bukkit.getWorld("tutorial");
        // generate world / location (maybe juste have a schematic and paste it in another part of the world...)
        File file = new File(Bukkit.getPluginsFolder() + "/Raxen/schematics/template_tuto.schem");
        Clipboard clipboard = null;
        ClipboardFormat format = ClipboardFormats.findByFile(file);
        try (ClipboardReader reader = format.getReader(new FileInputStream(file))) {
            clipboard = reader.read();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        try (EditSession editSession = WorldEdit.getInstance()
            .newEditSession(BukkitAdapter.adapt(world))) {
            Operation operation = new ClipboardHolder(clipboard)
                .createPaste(editSession)
                .to(BlockVector3.at(eX, eY, eZ))
                .ignoreAirBlocks(false)
                .build();
        }

        // gen holo

        // gen mobs / entities

        // gen loots

        // set global last x, y, z
        x = eX;
        y = eY;
        z = eZ;
        return new Location(world, x, y, z);
    }
}
